#!/usr/bin/python3
# -*- coding: utf-8 -*-

import os
import sys
import fcntl
import dbus.mainloop.glib
from gi.repository import GLib
from kylindbus.log_manager import logger


def exit_process(*args):
    try:
        fcntl.fcntl(pidfile, fcntl.LOCK_NB)
    except:
        logger.error("文件锁释放失败")
    sys.exit(0)


pidfile = 0
path = "/var/cache/kylin-update-manager/"


def dbus_instance():
    global pidfile
    if not os.path.exists(path):
        os.makedirs(path)
    pidfile = open(os.path.join(path, "kylin-update-manager-server.lock"), "w+")
    try:
        fcntl.flock(pidfile, fcntl.LOCK_EX | fcntl.LOCK_NB)
    except:
        logger.info("当前dbus服务正在运行，请关闭后再重试")
        sys.exit("当前dbus服务正在运行，请关闭后再重试")


if __name__ == '__main__':
    dbus_instance()
    os.environ["TERM"] = "xterm"
    os.environ["PATH"] = "/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/X11R6/bin"
    os.environ["DEBIAN_FRONTEND"] = "noninteractive"
    os.environ["DISPLAY"] = ":0"
    if os.getenv("LANG") == "zh_CN.UTF-8":  # 设置系统语言环境为中文
        os.environ["LANG"] = "zh_CN.UTF-8"
    os.environ["KYLIN_QUIET_INSTALL"] = "TRUE"  # 用于设置dpkg强配置
    if os.path.exists("/var/lib/apt/lists/lock"):
        os.remove("/var/lib/apt/lists/lock")
    from kylindbus.daemon import Daemon

    dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)
    # GObject.threads_init()
    mainloop = GLib.MainLoop()
    # signal.signal(signal.SIGINT, lambda : mainloop.quit())
    # signal.signal(signal.SIGTERM, lambda: mainloop.quit())
    # signal.signal(signal.SIGINT, exit_process)
    # signal.signal(signal.SIGTERM, exit_process)
    Daemon(dbus.SystemBus(), mainloop)
    mainloop.run()
