#!/usr/bin/python3
# -*- coding: utf-8 -*-

from PyQt5.QtCore import pyqtSignal
from apt import package
import gettext, tarfile
import os
from xdg import BaseDirectory as xdg
gettext.textdomain("kylin-update-manager")
_ = gettext.gettext

INTERFACE = "cn.kylinos.KylinUpdateManager"
INTERFACES = "/cn/kylinos/KylinUpdateManager"
SINTERFACE = "cn.kylinos.KylinUpdateManager.singleton"
SINTERFACES = "/cn/kylinos/KylinUpdateManager/singleton"
DB_FILE = os.path.join("/var/cache/kylin-update-manager/kylin-update-manager.db")
PINGBACK_INTERNET_URL = "http://archive1.kylinos.cn:32294/kylin-update-manager-server/main.php?"
PINGBACK_INTERNET_FILE_URL = "http://archive1.kylinos.cn:32294/kylin-update-manager-server/get_file.php?"
PINGBACK_INTRANET_URL = "http://archive.kylinos-intranet.cn/kylin-update-manager-server/main.php?"
PINGBACK_INTRANET_FILE_URL = "http://archive.kylinos-intranet.cn/kylin-update-manager-server/get_file.php?"
LOG_PATH = "/var/log/kylin-update-manager"
JSON_PKGNAME = "kylin-update-desktop-config"
JSON_PATH = "/usr/share/kylin-update-desktop-config/data/"
JSON_PKG_NAME_LIST = ['kylin-update-desktop-system', 'kylin-update-desktop-security']
KYLIN_SOFTWARE_PROPERTIES_LOG = "/var/log/kylin-software-properties.log"
INSTALLED_LIST = [{"item": "errorcode", "type": "int", "default": "0"}]
DISPALY_LIST = []

class AppActions:
    INSTALLDEPS = "install_deps"
    INSTALLDEBFILE = "install_debfile"
    INSTALL = "install"
    REMOVE = "remove"
    UPGRADE = "upgrade"
    CANCEL = "cancel"
    APPLY = "apply_changes"
    PURCHASE = "purchase"
    UPDATE = "update"
    UPDATE_FIRST = "update_first"
    ADD_SOURCE = "add_source"
    REMOVE_SOURCE = "remove_source"
    GET_SOURCES = "get_sources"

class AppMsg:
    ZH_CN_NAME = ""
    NAME = ""
    ICON = ""
    SIZE = ""
    BYTESIZE = 0
    INSTALLEDVERSION = ""
    CANDIDATEVERSION = ""
    DESCRIPTION = ""
    STATUE = ""
    TIME = ""
    ARCHITECTURE = ""
    FULLVERSION = ""
    TYPE = ""

#
# 函數：用于检查apt或dpkg是否被锁
#
def check_apt_lock():
    result = os.popen("ps -u root | awk '{print $4}'").readlines()
    for i in result:
        if i.strip("\n") == "apt" or i.strip("\n") == "apt-get" or i.strip("\n") == "dpkg":
            return False
        if i == result[len(result)-1]:
            if os.path.exists("/var/cache/apt/archives/lock"):
                os.remove("/var/cache/apt/archives/lock")
            elif os.path.exists("/var/lib/dpkg/lock"):
                os.remove("/var/lib/dpkg/lock")
            os.system("dpkg --configure -a")
            os.system("apt-get install -f -y")
            return True

#
# 函数：压缩文件
#
def gZipFile(src, dst):
  with tarfile.open(dst, "w:gz") as tar:
      tar.add(src, arcname=os.path.basename(src))